/***********************************************************
Gmail
***********************************************************/
function initHandler4(handler){
  handler.hostString="gmail.com";
  handler.initStage=ST_PRE;
  var inboxOnly=handler.webMailNotifier.prefBranch.getBoolPref("webmail4.inboxOnly");
  handler.queryString="as_has=is%3Aunread&as_subset="+(inboxOnly?"inbox":"all")+"&search=adv";

  var ar=handler.user.split("@");
  if(ar[1]=="gmail.com"||ar[1]=="googlemail.com"){
    handler.dataURL="https://mail.google.com/mail";
    handler.loginData=["https://www.google.com/accounts/ServiceLoginAuth?service=mail",
                      "Email","Passwd",
                      "continue=https%3A%2F%2Fmail.google.com%2Fmail%2F%3F"];
    handler.mailURL="https://mail.google.com/mail";//used in below process!
  }else{//Google Apps
    handler.dataURL="https://mail.google.com/a/"+ar[1];
    handler.mailURL="https://mail.google.com/a/"+ar[1];//used in below process!
    handler.loginData=["https://www.google.com/a/"+ar[1]+"/LoginAction2?service=mail",
                      "","Passwd",
                      "continue="+encodeURIComponent(handler.mailURL)+"&service=mail&Email="+ar[0]];
  }

  handler.process=function (aHttpChannel, aData) {
 	  switch(this.stage){
    case ST_PRE:
      this.webMailNotifier.getHtml(this,this.mailURL);
      return false;
    case ST_PRE_RES:
      var fnd=aData.match(/GALX[\s\S]+?value=\"(\S+?)\"/);
      if(fnd){
        this.stage=ST_LOGIN;
        this.webMailNotifier.getHtml(this,this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+"&GALX="+fnd[1]);
        return false;
      }
      this.onError();
      return true;
    case ST_LOGIN_RES:
	    var fnd=aData.match(/<meta.+?url=(?:'|&#39;)(\S+)(?:'|&#39;)/);
	    if(fnd){
	      fnd=fnd[1].replace(/&amp;/g,"&");
	      this.webMailNotifier.getHtml(this,fnd);
	      return false;
	    }
	    ++this.stage;//Google Apps
	  case (ST_LOGIN_RES+1):
	    this.webMailNotifier.getHtml(this,this.mailURL);
	    return false;
	  case (ST_LOGIN_RES+2):
	    var fnd=aData.match(/GLOBALS=\[(?:(.*?),){10}/);
	    if(fnd){
	      fnd=fnd[1].replace(/\"/g,"");
	      this.dataURL=this.mailURL+"/?ui=2&ik="+fnd+"&view=tl&start=0&num=25&rt=h&"+this.queryString;
	      this.stage=ST_DATA;
	    }
	    break;
	  }
	  return WebMailHandler.prototype.process.call(this,aHttpChannel, aData);
  };
  handler.getData=function(aData){
    var fnd=aData.match(/D\(\["ti",.+?,\d*,\d*,(\d+)/);
    if(fnd){
      return fnd[1];
    }else{
      return -1;
    }
  };
}
